/*
* Original code by ©Kosada Incorporated released under MIT License, modified by Bodysoulspirit.
* This code may be modified and distributed under the terms of the MIT License.
* For more information, see https://vuo.org/license.
*/

#include "node.h"

VuoModuleMetadata({
					 "title" : "Cut Text with Append",
					 "keywords" : [ "character", "letter", "substring", "part", "piece", "string", "truncate", "trim", "subrange" ],
					 "description" : "Truncates a string and appends another chosen string if the text is longer than maximum.",
					 "version" : "1.0.0",
});

void nodeEvent
(
		VuoInputData(VuoText, {"default":"Your text here"}) text,
		VuoInputData(VuoInteger, {"default":7,"suggestedMin":1}) maximumCharacters,
		VuoInputData(VuoText, {"default":"..."}) append,
		VuoOutputData(VuoText) partialText
)
{
	VuoInteger count = VuoText_length(text);
	if (count > maximumCharacters){
		VuoText cutText = VuoText_substring(text, 1, maximumCharacters);
		VuoText texts[2] = {cutText, append};
		*partialText = VuoText_append(texts, 2);
	}
	else {*partialText = text;
	}
}
